Drag and drop in EJ2 JavaScript Tab control

2 May 202324 minutes to read

The Tab component allows you to drag and drop any item by setting allowDragAndDrop to true. Items can be reordered to any place by dragging and dropping them onto the desired location.

  • If you need to prevent dragging action for a particular item, the onDragStart event can be used which will trigger when the item drag is started. If you need to prevent dropping action for a particular item, the dragged event can be used which will trigger when the drag action is stopped.

  • The dragArea defines the area in which the draggable element movement will be occurring. Outside that area will be restricted for the draggable element movement.

  • The onDragStart event will be triggered before dragging the item from Tab.

  • The dragging event will be triggered when the Tab item is being dragged.

  • The dragged event will be triggered when the Tab item is dropped on the target element successfully.

In the following sample, the allowDragAndDrop property is enabled.

var tabObj = new ej.navigations.Tab({
    heightAdjustMode: 'Auto',
    allowDragAndDrop: true,
    dragArea: '#container',
    items: [
        {
            header: { text: 'India' },
            content: 'India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.'
        },
        {
            header: { text: 'Australia' },
            content: 'Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.'
        },
        {
            header: { text: 'USA' },
            content: 'The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.'
        },
        {
            header: { text: 'France' },
            content: 'France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.'
        }
    ]
});

//Render initialized Tab component
tabObj.appendTo('#draggableTab');
<html lang="en"><head><script src="https://cdn.syncfusion.com/ej2/25.1.35/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head><body>



    <title>Essential JS 2 for Tab </title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 for Tab UI Control">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/25.1.35/material.css" rel="stylesheet">
    <link href="index.css" rel="stylesheet">
    
    



    
    <div id="container">
        <div id="draggableTab"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Drag and drop item between tabs

It is possible to drag and drop the tab items between two tabs, by manually saving those dropped items as new tab item data through the addTab method of Tab and removing the dragged item through the removeTab method of Tab.

In this example, we have used the tab control as an external source, and the item from the tab component is dragged and dropped onto another Tab. Therefore, it is necessary to use the onDragStart and dragged event of the Tab component, where we can form an event object and save it using the addTab method of the Tab and remove the dragged item through removeTab method of Tab using the dragged item index.

var firstTabObj = new ej.navigations.Tab({
    heightAdjustMode: 'Auto',
    allowDragAndDrop: true,
    dragArea: '#container',
    onDragStart: firstTabdragStart,
    dragged: firstTabDragStop,
    items: [
        {
            header: { text: 'India' },
            content: 'India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.'
        },
        {
            header: { text: 'Australia' },
            content: 'Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.'
        },
        {
            header: { text: 'USA' },
            content: 'The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.'
        },
        {
            header: { text: 'France' },
            content: 'France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.'
        }
    ],
});
firstTabObj.appendTo('#firstTab');

var secondTabObj = new ej.navigations.Tab({
    heightAdjustMode: 'Auto',
    dragArea: '#container',
    allowDragAndDrop: true,
    onDragStart: secondTabDragStart,
    dragged: secondTabDragStop,
    items: [
        {
            header: { text: 'HTML' },
            content: 'HyperText Markup Language, commonly referred to as HTML, is the standard markup language used to create web pages. Along with CSS, and JavaScript, HTML is a cornerstone technology, used by most websites to create visually engaging web pages, user interfaces for web applications, and user interfaces for many mobile applications.[1] Web browsers can read HTML files and render them into visible or audible web pages. HTML describes the structure of a website semantically along with cues for presentation, making it a markup language, rather than a programming language.'
        },
        {
            header: { text: 'C Sharp(C#)' },
            content: 'C# is intended to be a simple, modern, general-purpose, object-oriented programming language. Its development team is led by Anders Hejlsberg. The most recent version is C# 5.0, which was released on August 15, 2012.'
        },
        {
            header: { text: 'Java' },
            content: 'Java is a set of computer software and specifications developed by Sun Microsystems, later acquired by Oracle Corporation, that provides a system for developing application software and deploying it in a cross-platform computing environment. Java is used in a wide variety of computing platforms from embedded devices and mobile phones to enterprise servers and supercomputers. While less common, Java applets run in secure, sandboxed environments to provide many features of native applications and can be embedded in HTML pages.'
        },
        {
            header: { text: 'VB.Net' },
            content: 'The command-line compiler, VBC.EXE, is installed as part of the freeware .NET Framework SDK. Mono also includes a command-line VB.NET compiler. The most recent version is VB 2012, which was released on August 15, 2012.'
        }
    ],
});
secondTabObj.appendTo('#secondTab');

var firstTabitem;
var secondTabitem;
var dragItemIndex;
var dragItemContainer;
function firstTabdragStart(args) {
    firstTabitem = [firstTabObj.items[args.index]];
    args.draggedItem.style.visibility = 'hidden';
    dragItemIndex = args.index;
    dragItemContainer = args.draggedItem.closest('.e-tab');
}
function firstTabDragStop(args) {
    if (!ej.base.isNullOrUndefined(args.target.closest('.e-tab')) && !dragItemContainer.isSameNode(args.target.closest('.e-tab'))) {
        args.cancel = true;
        var TabElement = args.target.closest('.e-tab');
        var dropItem = args.target.closest('.e-toolbar-item');
        if (TabElement != null && dropItem != null) {
            dragItemIndex = Array.prototype.indexOf.call(firstTabObj.element.querySelectorAll('.e-toolbar-item'), args.draggedItem);
            var dropItemContainer = args.target.closest('.e-toolbar-items');
            var dropItemIndex = (dropItemContainer != null) ? (Array.prototype.slice.call(dropItemContainer.querySelectorAll('.e-toolbar-item'))).indexOf(dropItem) : '';
            secondTabObj.addTab(firstTabitem, dropItemIndex);
            firstTabObj.removeTab(dragItemIndex);
        }
    }
}
function secondTabDragStart(args) {
    secondTabitem = [secondTabObj.items[args.index]];
    args.draggedItem.style.visibility = 'hidden';
    dragItemContainer = args.draggedItem.closest('.e-tab');
}
function secondTabDragStop(args) {
    if (!ej.base.isNullOrUndefined(args.target.closest('.e-tab')) && !dragItemContainer.isSameNode(args.target.closest('.e-tab'))) {
        args.cancel = true;
        var TabElement = args.target.closest('.e-tab');
        var dropItem = args.target.closest('.e-toolbar-item');
        if (TabElement != null && dropItem != null) {
            dragItemIndex = Array.prototype.indexOf.call(secondTabObj.element.querySelectorAll('.e-toolbar-item'), args.draggedItem);
            var dropItemContainer = args.target.closest('.e-toolbar-items');
            var dropItemIndex = (dropItemContainer != null) ? (Array.prototype.slice.call(dropItemContainer.querySelectorAll('.e-toolbar-item'))).indexOf(dropItem) : '';
            firstTabObj.addTab(secondTabitem, dropItemIndex);
            secondTabObj.removeTab(dragItemIndex);
        }
    }
}
<html lang="en"><head><script src="https://cdn.syncfusion.com/ej2/25.1.35/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head><body>



    <title>Essential JS 2 for Tab </title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 for Tab UI Control">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/25.1.35/material.css" rel="stylesheet">
    <link href="index.css" rel="stylesheet">
    
    



    
    <div id="container" style="height: auto">
        <div id="firstTab" style="height:auto">
        </div>
        <div id="secondTab" style="height:auto">
        </div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Drag and drop items to external source

It is possible to drag and drop the items to any of the external sources from the Tab, by manually saving those dropped items as new node data through the addNodes method of Treeview and removing the dragged item through the removeTab method of Tab.

In this example, we have used the tree view control as an external source, and the item from the tab component is dragged and dropped onto the child nodes of the tree view component. Therefore, it is necessary to use the dragged event of the Tab component, where we can form an event object and save it using the addNodes method of the Treeview and remove the dragged item through the removeTab method of Tab using the dragged item index.

var tabObj = new ej.navigations.Tab({
    created: onTabCreate,
    heightAdjustMode: 'Auto',
    dragArea: '#container',
    allowDragAndDrop: true,
    dragged: tabDragStop,
    items: [
        {
            header: { 'text': 'India' },
            content: 'India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.'
        },
        {
            header: { 'text': 'Australia' },
            content: 'Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.'
        },
        {
            header: { 'text': 'USA' },
            content: 'The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.'
        },
        {
            header: { 'text': 'France' },
            content: 'France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.'
        }
    ],
});
tabObj.appendTo('#draggableTab');

var data = [
    { text: 'Hennessey Venom', id: 'list-01' },
    { text: 'Bugatti Chiron', id: 'list-02' },
    { text: 'Bugatti Veyron Super Sport', id: 'list-03' },
    { text: 'SSC Ultimate Aero', id: 'list-04' },
    { text: 'Koenigsegg CCR', id: 'list-05' },
    { text: 'McLaren F1', id: 'list-06' },
    { text: 'Aston Martin One- 77', id: 'list-07' },
    { text: 'Jaguar XJ220', id: 'list-08' },
    { text: 'McLaren P1', id: 'list-09' },
    { text: 'Ferrari LaFerrari', id: 'list-10' },
];

var treeViewInstance = new ej.navigations.TreeView({
    fields: { dataSource: data, id: 'id', text: 'text' },
    cssClass: 'treeview-external-drop-tab'
});
treeViewInstance.appendTo('#draggableTreeview');

var i = 0;
function onTabCreate() {
    var tabElement = document.getElementById('draggableTab');
    if (!ej.base.isNullOrUndefined(tabElement)) {
        tabElement.querySelector('.e-tab-header').classList.add('e-droppable');
        tabElement.querySelector('.e-content').classList.add('tab-content');
    }
}
function tabDragStop(args) {
    var dragTabIndex = Array.prototype.indexOf.call(tabObj.element.querySelectorAll('.e-toolbar-item'), args.draggedItem);
    var dragItem = tabObj.items[dragTabIndex];
    var dropNode = args.target.closest('#draggableTreeview .e-list-item');
    if (dropNode != null && !args.target.closest('#draggableTab .e-toolbar-item')) {
        args.cancel = true;
        var dropContainer = (document.querySelector('.treeview-external-drop-tab')).querySelectorAll('.e-list-item');
        var dropIndex = Array.prototype.indexOf.call(dropContainer, dropNode);
        var newNode = [{ id: 'list' + i, text: dragItem.header.text }];
        tabObj.removeTab(dragTabIndex);
        treeViewInstance.addNodes(newNode, 'Treeview', dropIndex);
    }
}
<html lang="en"><head><script src="https://cdn.syncfusion.com/ej2/25.1.35/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head><body>



    <title>Essential JS 2 for Tab </title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 for Tab UI Control">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/25.1.35/material.css" rel="stylesheet">
    <link href="index.css" rel="stylesheet">
    
    



    
    <div id="container" style="height: auto">
        <div id="draggableTab"></div>
        <div id="draggableTreeview"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Drag and drop items from external source

It is possible to drag and drop the items from any of the external sources into the Tab, by manually saving those dropped items as new item data through the addTab method of Tab and removing the dragged node through the removeNodes method of Treeview.

In this example, we have used the tree view control as an external source, and the child nodes from the tree view component are dragged and dropped onto the Tab. Therefore, it is necessary to use the nodeDragStop event of the Treeview component, where we can form an event object and save it using the addTab method of the Tab and remove the dragged node through the removeNodes method of Treeview.

var tabObj = new ej.navigations.Tab({
    heightAdjustMode: 'Auto',
    dragArea: '#container',
    items: [
        {
            header: { 'text': 'India' },
            content: 'India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.'
        },
        {
            header: { 'text': 'Australia' },
            content: 'Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.'
        },
        {
            header: { 'text': 'USA' },
            content: 'The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.'
        },
        {
            header: { 'text': 'France' },
            content: 'France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.'
        }
    ],
});
tabObj.appendTo('#draggableTab');

var data = [
    { text: 'Hennessey Venom', id: 'list-01' },
    { text: 'Bugatti Chiron', id: 'list-02' },
    { text: 'Bugatti Veyron Super Sport', id: 'list-03' },
    { text: 'SSC Ultimate Aero', id: 'list-04' },
    { text: 'Koenigsegg CCR', id: 'list-05' },
    { text: 'McLaren F1', id: 'list-06' },
    { text: 'Aston Martin One- 77', id: 'list-07' },
    { text: 'Jaguar XJ220', id: 'list-08' },
    { text: 'McLaren P1', id: 'list-09' },
    { text: 'Ferrari LaFerrari', id: 'list-10' },
];

var treeViewObj = new ej.navigations.TreeView({
    fields: { dataSource: data, id: 'id', text: 'text' },
    allowDragAndDrop: true,
    dragArea: '#container',
    nodeDragStop: onNodeDragStop,
    nodeDragging: onNodeDrag,
    cssClass: 'treeview-external-drop-tab'
});
treeViewObj.appendTo('#draggableTreeview');

function onNodeDragStop(args) {
    var dropElement = args.target.closest('#draggableTab .e-toolbar-item');
    if (dropElement != null) {
        var tabElement = document.querySelector('#draggableTab');
        var dropItemIndex = [].slice.call(tabElement.querySelectorAll('.e-toolbar-item')).indexOf(dropElement);
        var newTabItem = [{
                header: { 'text': args.draggedNodeData.text.toString() },
                content: args.draggedNodeData.text.toString() + ' Content'
            }];
        tabObj.addTab(newTabItem, dropItemIndex);
        treeViewObj.removeNodes([args.draggedNode]);
        args.cancel = true;
    }
    else {
        var dropNode = args.target.closest('#draggableTreeview .e-list-item ');
        if (!ej.base.isNullOrUndefined(dropNode) && args.dropIndicator === 'e-drop-in') {
            args.cancel = true;
        }
    }
}

function onNodeDrag(args) {
    if (!ej.base.isNullOrUndefined(args.target.closest('.tab-content'))) {
        args.dropIndicator = 'e-no-drop';
    }
    else if (!ej.base.isNullOrUndefined(args.target.closest('#draggableTab .e-tab-header'))) {
        args.dropIndicator = 'e-drop-in';
    }
}
<html lang="en"><head><script src="https://cdn.syncfusion.com/ej2/25.1.35/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head><body>



    <title>Essential JS 2 for Tab </title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 for Tab UI Control">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/25.1.35/material.css" rel="stylesheet">
    <link href="index.css" rel="stylesheet">
    
    



    
    <div id="container" style="height: auto">
        <div id="draggableTab"></div>
        <div id="draggableTreeview"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Drag and drop in Vue Tab component

1 Dec 202324 minutes to read

The Tab component allows you to drag and drop any item by setting allowDragAndDrop to true. Items can be reordered to any place by dragging and dropping them onto the desired location.

  • If you need to prevent dragging action for a particular item, the onDragStart event can be used which will trigger when the item drag is started. If you need to prevent dropping action for a particular item, the dragged event can be used which will trigger when the drag action is stopped.

  • The dragArea defines the area in which the draggable element movement will be occurring. Outside that area will be restricted for the draggable element movement.

  • The onDragStart event will be triggered before dragging the item from Tab.

  • The dragging event will be triggered when the Tab item is being dragged.

  • The dragged event will be triggered when the Tab item is dropped on the target element successfully.

In the following sample, the allowDragAndDrop property is enabled.

<template>
    <div id="app">
        <div id='container'>
            <ejs-tab id='draggableTab' heightAdjustMode='Auto' :allowDragAndDrop="true" dragArea="#container">
                <e-tabitems>
                    <e-tabitem :header='headerText0' :content="content0"></e-tabitem>
                    <e-tabitem :header='headerText1' :content="content1"></e-tabitem>
                    <e-tabitem :header='headerText2' :content="content2"></e-tabitem>
                    <e-tabitem :header='headerText3' :content="content3"></e-tabitem>
                </e-tabitems>
            </ejs-tab>
        </div>
  </div>
</template>
<style>
    #draggableTab .e-content .e-item {
        font-size: 12px;
        margin: 10px;
        text-align: justify;
    }
</style>
<script>
import Vue from 'vue';
import { TabPlugin } from '@syncfusion/ej2-vue-navigations';

Vue.use(TabPlugin);
export default {
  name: 'app',
   data: function(){
        return {

        headerText0: { text: 'India' },
        headerText1: { text: 'Australia' },
        headerText2: { text: 'USA' },
        headerText3: { text: 'France' },

        content0: 'India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.',

        content1: 'Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.',

        content2: 'The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.',

        content3: 'France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.',

        }
   }
}
</script>
<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
</style>

Drag and drop item between tabs

It is possible to drag and drop the tab items between two tabs, by manually saving those dropped items as new tab item data through the addTab method of Tab and removing the dragged item through the removeTab method of Tab.

In this example, we have used the tab control as an external source, and the item from the tab component is dragged and dropped onto another Tab. Therefore, it is necessary to use the onDragStart and dragged event of the Tab component, where we can form an event object and save it using the addTab method of the Tab and remove the dragged item through removeTab method of Tab using the dragged item index.

<template>
    <div id="app">
        <div id='container'>
           <ejs-tab ref="firstTabObj" id='firstTab' heightAdjustMode='Auto' :allowDragAndDrop="true" dragArea="#container" :onDragStart="firstTabdragStart" :dragged="firstTabDragStop">
                <e-tabitems>
                    <e-tabitem :header='headerText0' :content="content0"></e-tabitem>
                    <e-tabitem :header='headerText1' :content="content1"></e-tabitem>
                    <e-tabitem :header='headerText2' :content="content2"></e-tabitem>
                    <e-tabitem :header='headerText3' :content="content3"></e-tabitem>
                </e-tabitems>
            </ejs-tab>
            <ejs-tab ref="secondTabObj" id='secondTab' heightAdjustMode='Auto' :allowDragAndDrop="true" dragArea="#container" :onDragStart="secondTabDragStart" :dragged="secondTabDragStop">
                <e-tabitems>
                    <e-tabitem :header='headerText4' :content="content4"></e-tabitem>
                    <e-tabitem :header='headerText5' :content="content5"></e-tabitem>
                    <e-tabitem :header='headerText6' :content="content6"></e-tabitem>
                    <e-tabitem :header='headerText7' :content="content7"></e-tabitem>
                </e-tabitems>
            </ejs-tab>
        </div>
  </div>
</template>
<style>
    #firstTab .e-content .e-item,
    #secondTab .e-content .e-item {
        font-size: 12px;
        margin: 10px;
        text-align: justify;
    }

    #firstTab {
        margin-bottom: 40px;
    }

    #secondTab {
        margin-top: 40px;
    }
</style>
<script>
import Vue from 'vue';
import { TabPlugin } from '@syncfusion/ej2-vue-navigations';
import { isNullOrUndefined } from "@syncfusion/ej2-base";

Vue.use(TabPlugin);
export default {
  name: 'app',
    data: function(){
        return {

        headerText0: { text: 'India' },
        headerText1: { text: 'Australia' },
        headerText2: { text: 'USA' },
        headerText3: { text: 'France' },
        headerText4: { text: 'HTML' },
        headerText5: { text: 'C Sharp(C#)' },
        headerText6: { text: 'Java' },
        headerText7: { text: 'VB.Net' },
        firstTabitem: {},
        secondTabitem: {},
        dragItemContainer: "",
        dragItemIndex: 0,

        content0: 'India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.',

        content1: 'Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.',

        content2: 'The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.',

        content3: 'France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.',

        content4: 'HyperText Markup Language, commonly referred to as HTML, is the standard markup language used to create web pages. Along with CSS, and JavaScript, HTML is a cornerstone technology, used by most websites to create visually engaging web pages, user interfaces for web applications, and user interfaces for many mobile applications.[1] Web browsers can read HTML files and render them into visible or audible web pages. HTML describes the structure of a website semantically along with cues for presentation, making it a markup language, rather than a programming language.',

        content5: 'C# is intended to be a simple, modern, general-purpose, object-oriented programming language. Its development team is led by Anders Hejlsberg. The most recent version is C# 5.0, which was released on August 15, 2012.',

        content6: 'Java is a set of computer software and specifications developed by Sun Microsystems, later acquired by Oracle Corporation, that provides a system for developing application software and deploying it in a cross-platform computing environment. Java is used in a wide variety of computing platforms from embedded devices and mobile phones to enterprise servers and supercomputers. While less common, Java applets run in secure, sandboxed environments to provide many features of native applications and can be embedded in HTML pages.',

        content7: 'The command-line compiler, VBC.EXE, is installed as part of the freeware .NET Framework SDK. Mono also includes a command-line VB.NET compiler. The most recent version is VB 2012, which was released on August 15, 2012.',

        }
    },
    methods: {
        firstTabdragStart: function (args) {
            var firstTabObj = this.$refs.firstTabObj.ej2Instances;
            this.firstTabitem = [firstTabObj.items[args.index]];
            args.draggedItem.style.visibility = 'hidden';
            this.dragItemContainer = args.draggedItem.closest('.e-tab');
        },
        firstTabDragStop: function (args) {
            if (!isNullOrUndefined(args.target.closest('.e-tab')) && !this.dragItemContainer.isSameNode(args.target.closest('.e-tab'))) {
                args.cancel = true;
                let TabElement = args.target.closest('.e-tab');
                let dropItem = args.target.closest('.e-toolbar-item');
                if (TabElement != null && dropItem != null) {
                    var firstTabObj = this.$refs.firstTabObj.ej2Instances;
                    var secondTabObj = this.$refs.secondTabObj.ej2Instances;
                    this.dragItemIndex = Array.prototype.indexOf.call(firstTabObj.element.querySelectorAll('.e-toolbar-item'), args.draggedItem);
                    let dropItemContainer = args.target.closest('.e-toolbar-items');
                    let dropItemIndex = (dropItemContainer != null) ? (Array.prototype.slice.call(dropItemContainer.querySelectorAll('.e-toolbar-item'))).indexOf(dropItem) : '';
                    secondTabObj.addTab(this.firstTabitem, dropItemIndex);
                    firstTabObj.removeTab(this.dragItemIndex);
                }
            }
        },
        secondTabDragStart: function (args) {
            var secondTabObj = this.$refs.secondTabObj.ej2Instances;
            this.secondTabitem = [secondTabObj.items[args.index]];
            args.draggedItem.style.visibility = 'hidden';
            this.dragItemContainer = args.draggedItem.closest('.e-tab');
        },
        secondTabDragStop: function (args) {
            if (!isNullOrUndefined(args.target.closest('.e-tab')) && !this.dragItemContainer.isSameNode(args.target.closest('.e-tab'))) {
                args.cancel = true;
                let TabElement = args.target.closest('.e-tab');
                let dropItem = args.target.closest('.e-toolbar-item');
                if (TabElement != null && dropItem != null) {
                    var firstTabObj = this.$refs.firstTabObj.ej2Instances;
                    var secondTabObj = this.$refs.secondTabObj.ej2Instances;
                    this.dragItemIndex = Array.prototype.indexOf.call(secondTabObj.element.querySelectorAll('.e-toolbar-item'), args.draggedItem);
                    let dropItemContainer = args.target.closest('.e-toolbar-items');
                    let dropItemIndex = (dropItemContainer != null) ? (Array.prototype.slice.call(dropItemContainer.querySelectorAll('.e-toolbar-item'))).indexOf(dropItem) : '';
                    firstTabObj.addTab(this.secondTabitem, dropItemIndex);
                    secondTabObj.removeTab(this.dragItemIndex);
                }
            }
        },
    }
}
</script>
<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
</style>

Drag and drop items to external source

It is possible to drag and drop the items to any of the external sources from the Tab, by manually saving those dropped items as new node data through the addNodes method of Treeview and removing the dragged item through the removeTab method of Tab.

In this example, we have used the tree view control as an external source, and the item from the tab component is dragged and dropped onto the child nodes of the tree view component. Therefore, it is necessary to use the dragged event of the Tab component, where we can form an event object and save it using the addNodes method of the Treeview and remove the dragged item through the removeTab method of Tab using the dragged item index.

<template>
    <div id="app">
        <div id='container'>
            <ejs-tab ref="tabObj" id='draggableTab' heightAdjustMode='Auto' :allowDragAndDrop="true" dragArea="#container" :created="onTabCreate" :dragged="tabDragStop">
                <e-tabitems>
                    <e-tabitem :header='headerText0' :content="content0"></e-tabitem>
                    <e-tabitem :header='headerText1' :content="content1"></e-tabitem>
                    <e-tabitem :header='headerText2' :content="content2"></e-tabitem>
                    <e-tabitem :header='headerText3' :content="content3"></e-tabitem>
                </e-tabitems>
            </ejs-tab>
            <ejs-treeview ref="treeObj" id="draggableTreeview" :fields="fields" cssClass="treeview-external-drop-tab">
            </ejs-treeview>
        </div>
  </div>
</template>
<style>
    #draggableTab .e-content .e-item {
        font-size: 12px;
        margin: 10px;
        text-align: justify;
    }

    .treeview-external-drop-tab .e-list-item,
    .e-bigger .treeview-external-drop-tab .e-list-item {
        border: 0.5px solid #E1E7EC;
        line-height: 15px;
        padding: 0 5px;
    }

    .treeview-external-drop-tab .e-list-item.e-hover>.e-fullrow,
    .treeview-external-drop-tab .e-list-item.e-active>.e-fullrow,
    .treeview-external-drop-tab .e-list-item.e-active.e-hover>.e-fullrow,
    .e-bigger .treeview-external-drop-tab .e-list-item.e-hover>.e-fullrow,
    .e-bigger .treeview-external-drop-tab .e-list-item.e-active>.e-fullrow,
    .e-bigger .treeview-external-drop-tab .e-list-item.e-active.e-hover>.e-fullrow {
        background-color: transparent;
        border-color: transparent;
        box-shadow: none !important;
    }

    #draggableTab {
        margin-bottom: 40px;
    }

    #draggableTreeview {
        margin-top: 40px;
    }
</style>
<script>
import Vue from 'vue';
import { TabPlugin, TreeViewPlugin } from "@syncfusion/ej2-vue-navigations";
import { isNullOrUndefined } from "@syncfusion/ej2-base";

Vue.use(TabPlugin);
Vue.use(TreeViewPlugin);
export default {
  name: 'app',
    data: function(){
        return {

        headerText0: { text: 'India' },
        headerText1: { text: 'Australia' },
        headerText2: { text: 'USA' },
        headerText3: { text: 'France' },
        fields: {
            dataSource: [
                { text: 'Hennessey Venom', id: 'list-01' },
                { text: 'Bugatti Chiron', id: 'list-02' },
                { text: 'Bugatti Veyron Super Sport', id: 'list-03' },
                { text: 'SSC Ultimate Aero', id: 'list-04' },
                { text: 'Koenigsegg CCR', id: 'list-05' },
                { text: 'McLaren F1', id: 'list-06' },
                { text: 'Aston Martin One- 77', id: 'list-07' },
                { text: 'Jaguar XJ220', id: 'list-08' },
                { text: 'McLaren P1', id: 'list-09' },
                { text: 'Ferrari LaFerrari', id: 'list-10' },
            ],
            id: "id", text: "text",
        },
        i: 0,

        content0: 'India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.',

        content1: 'Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.',

        content2: 'The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.',

        content3: 'France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.',

        }
    },
    methods: {
        onTabCreate: function () {
            let tabElement = document.getElementById('draggableTab');
            if (!isNullOrUndefined(tabElement)) {
                tabElement.querySelector('.e-tab-header').classList.add('e-droppable');
                tabElement.querySelector('.e-content').classList.add('tab-content');
            }
        },
        tabDragStop: function (args) {
            var tabObj = this.$refs.tabObj.ej2Instances;
            var treeObj = this.$refs.treeObj.ej2Instances;
            let dragTabIndex = Array.prototype.indexOf.call(tabObj.element.querySelectorAll('.e-toolbar-item'), args.draggedItem);
            let dragItem = tabObj.items[dragTabIndex];
            let dropNode = args.target.closest('#draggableTreeview .e-list-item');
            if (dropNode != null && !args.target.closest('#draggableTab .e-toolbar-item')) {
                args.cancel = true;
                let dropContainer = (document.querySelector('.treeview-external-drop-tab')).querySelectorAll('.e-list-item');
                let dropIndex = Array.prototype.indexOf.call(dropContainer, dropNode);
                let newNode = [{ id: 'list' + this.i, text: dragItem.header.text }];
                tabObj.removeTab(dragTabIndex);
                treeObj.addNodes(newNode, 'Treeview', dropIndex);
            }
        },
    }
}
</script>
<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
</style>

Drag and drop items from external source

It is possible to drag and drop the items from any of the external sources into the Tab, by manually saving those dropped items as new item data through the addTab method of Tab and removing the dragged node through the removeNodes method of Treeview.

In this example, we have used the tree view control as an external source, and the child nodes from the tree view component are dragged and dropped onto the Tab. Therefore, it is necessary to use the nodeDragStop event of the Treeview component, where we can form an event object and save it using the addTab method of the Tab and remove the dragged node through the removeNodes method of Treeview.

<template>
    <div id="app">
        <div id='container'>
            <ejs-tab ref="tabObj" id='draggableTab' heightAdjustMode='Auto' dragArea="#container">
                <e-tabitems>
                    <e-tabitem :header='headerText0' :content="content0"></e-tabitem>
                    <e-tabitem :header='headerText1' :content="content1"></e-tabitem>
                    <e-tabitem :header='headerText2' :content="content2"></e-tabitem>
                    <e-tabitem :header='headerText3' :content="content3"></e-tabitem>
                </e-tabitems>
            </ejs-tab>
            <ejs-treeview ref="treeObj" id="draggableTreeview" :fields="fields" :allowDragAndDrop="true" dragArea="#container" cssClass="treeview-external-drop-tab" :nodeDragStop="onNodeDragStop" :nodeDragging="onNodeDrag">
            </ejs-treeview>
        </div>
  </div>
</template>
<style>
    #draggableTab .e-content .e-item {
        font-size: 12px;
        margin: 10px;
        text-align: justify;
    }

    .treeview-external-drop-tab .e-list-item,
    .e-bigger .treeview-external-drop-tab .e-list-item {
        border: 0.5px solid #E1E7EC;
        line-height: 15px;
        padding: 0 5px;
    }

    .treeview-external-drop-tab .e-list-item.e-hover>.e-fullrow,
    .treeview-external-drop-tab .e-list-item.e-active>.e-fullrow,
    .treeview-external-drop-tab .e-list-item.e-active.e-hover>.e-fullrow,
    .e-bigger .treeview-external-drop-tab .e-list-item.e-hover>.e-fullrow,
    .e-bigger .treeview-external-drop-tab .e-list-item.e-active>.e-fullrow,
    .e-bigger .treeview-external-drop-tab .e-list-item.e-active.e-hover>.e-fullrow {
        background-color: transparent;
        border-color: transparent;
        box-shadow: none !important;
    }

    #draggableTab {
        margin-bottom: 40px;
    }

    #draggableTreeview {
        margin-top: 40px;
    }
</style>
<script>
import Vue from 'vue';
import { TabPlugin, TreeViewPlugin } from "@syncfusion/ej2-vue-navigations";
import { isNullOrUndefined } from "@syncfusion/ej2-base";

Vue.use(TabPlugin);
Vue.use(TreeViewPlugin);
export default {
  name: 'app',
    data: function(){
        return {

        headerText0: { text: 'India' },
        headerText1: { text: 'Australia' },
        headerText2: { text: 'USA' },
        headerText3: { text: 'France' },
        fields: {
            dataSource: [
                { text: 'Hennessey Venom', id: 'list-01' },
                { text: 'Bugatti Chiron', id: 'list-02' },
                { text: 'Bugatti Veyron Super Sport', id: 'list-03' },
                { text: 'SSC Ultimate Aero', id: 'list-04' },
                { text: 'Koenigsegg CCR', id: 'list-05' },
                { text: 'McLaren F1', id: 'list-06' },
                { text: 'Aston Martin One- 77', id: 'list-07' },
                { text: 'Jaguar XJ220', id: 'list-08' },
                { text: 'McLaren P1', id: 'list-09' },
                { text: 'Ferrari LaFerrari', id: 'list-10' },
            ],
            id: "id", text: "text",
        },

        content0: 'India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.',

        content1: 'Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.',

        content2: 'The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.',

        content3: 'France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.',

        }
    },
    methods: {
        onNodeDragStop: function (args) {
            var tabObj = this.$refs.tabObj.ej2Instances;
            var treeObj = this.$refs.treeObj.ej2Instances;
            let dropElement = args.target.closest('#draggableTab .e-toolbar-item');
            if (dropElement != null) {
                let tabElement = document.querySelector('#draggableTab');
                let dropItemIndex = [].slice.call(tabElement.querySelectorAll('.e-toolbar-item')).indexOf(dropElement);
                let newTabItem = [{
                    header: { 'text': args.draggedNodeData.text.toString() },
                    content: args.draggedNodeData.text.toString() + ' Content'
                }];
                tabObj.addTab(newTabItem, dropItemIndex);
                treeObj.removeNodes([args.draggedNode]);
                args.cancel = true;
            } else {
                let dropNode = args.target.closest('#draggableTreeview .e-list-item ');
                if (!isNullOrUndefined(dropNode) && args.dropIndicator === 'e-drop-in') {
                    args.cancel = true;
                }
            }
        },
        onNodeDrag: function (args) {
            if (!isNullOrUndefined(args.target.closest('.tab-content'))) {
                args.dropIndicator = 'e-no-drop';
            } else if (!isNullOrUndefined(args.target.closest('#draggableTab .e-tab-header'))) {
                args.dropIndicator = 'e-drop-in';
            }
        },
    }
}
</script>
<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
</style>

Drag and drop in React Tab component

29 Aug 202324 minutes to read

The Tab component allows you to drag and drop any item by setting allowDragAndDrop to true. Items can be reordered to any place by dragging and dropping them onto the desired location.

  • If you need to prevent dragging action for a particular item, the onDragStart event can be used which will trigger when the item drag is started. If you need to prevent dropping action for a particular item, the dragged event can be used which will trigger when the drag action is stopped.

  • The dragArea defines the area in which the draggable element movement will be occurring. Outside that area will be restricted for the draggable element movement.

  • The onDragStart event will be triggered before dragging the item from Tab.

  • The dragging event will be triggered when the Tab item is being dragged.

  • The dragged event will be triggered when the Tab item is dropped on the target element successfully.

In the following sample, the allowDragAndDrop property is enabled.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-react-navigations';

const ReactApp = () => {

  let headerText = [{ text: "India" }, { text: "Australia" }, { text: "USA" }, { text: "France" }];

  const indiaContent = () => {
    return <div>
      India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.
    </div>;
  }
  const australiaContent = () => {
    return <div>
      Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.
    </div>;
  }
  const unitedContent = () => {
    return <div>
      The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.
    </div>;
  }
  const franceContent = () => {
    return <div>
      France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.
    </div>;
  }

  return (
    <TabComponent id='draggableTab' heightAdjustMode='Auto' allowDragAndDrop={true} dragArea="#container">
      <TabItemsDirective>
        <TabItemDirective header={headerText[0]} content={indiaContent} />
        <TabItemDirective header={headerText[1]} content={australiaContent} />
        <TabItemDirective header={headerText[2]} content={unitedContent} />
        <TabItemDirective header={headerText[3]} content={franceContent} />
      </TabItemsDirective>
    </TabComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-react-navigations';

const ReactApp = () => {

  let headerText: any = [{ text: "India" }, { text: "Australia" }, { text: "USA" }, { text: "France" }];

  const indiaContent = () => {
    return <div>
      India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.
    </div>;
  }
  const australiaContent = () => {
    return <div>
      Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.
    </div>;
  }
  const unitedContent = () => {
    return <div>
      The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.
    </div>;
  }
  const franceContent = () => {
    return <div>
      France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.
    </div>;
  }

  return (
    <TabComponent id='draggableTab' heightAdjustMode='Auto' allowDragAndDrop={true} dragArea="#container">
      <TabItemsDirective>
        <TabItemDirective header={headerText[0]} content={indiaContent} />
        <TabItemDirective header={headerText[1]} content={australiaContent} />
        <TabItemDirective header={headerText[2]} content={unitedContent} />
        <TabItemDirective header={headerText[3]} content={franceContent} />
      </TabItemsDirective>
    </TabComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);

Drag and drop item between tabs

It is possible to drag and drop the tab items between two tabs, by manually saving those dropped items as new tab item data through the addTab method of Tab and removing the dragged item through the removeTab method of Tab.

In this example, we have used the tab control as an external source, and the item from the tab component is dragged and dropped onto another Tab. Therefore, it is necessary to use the onDragStart and dragged event of the Tab component, where we can form an event object and save it using the addTab method of the Tab and remove the dragged item through removeTab method of Tab using the dragged item index.

import { useRef } from 'react';
import * as React from "react";
import * as ReactDOM from 'react-dom';
import { TabComponent, TabItemDirective, TabItemsDirective, DragEventArgs } from '@syncfusion/ej2-react-navigations';
import { isNullOrUndefined } from "@syncfusion/ej2-base";
const ReactApp = () => {
  const firstTabObj = useRef(null);
  const secondTabObj = useRef(null);
  let headerText = [{ text: "India" }, { text: "Australia" }, { text: "USA" }, { text: "France" }, { text: "HTML" }, { text: "C Sharp(C#)" }, { text: "Java" }, { text: "VB.Net" }];
  let allowDragAndDrop = true;
  let firstTabitem = [];
  let secondTabitem = [];
  let dragItemIndex;
  let dragItemContainer;

  const firstTabdragStart = (args) => {
    firstTabitem = [firstTabObj.current.items[args.index]];
    args.draggedItem.style.visibility = 'hidden';
    dragItemContainer = args.draggedItem.closest('.e-tab');
  }

  const firstTabDragStop = (args) => {
    if (!isNullOrUndefined(args.target.closest('.e-tab')) && !dragItemContainer.isSameNode(args.target.closest('.e-tab'))) {
      args.cancel = true;
      let TabElement = args.target.closest('.e-tab');
      let dropItem = args.target.closest('.e-toolbar-item');
      if (TabElement != null && dropItem != null) {
        dragItemIndex = Array.prototype.indexOf.call(firstTabObj.current.element.querySelectorAll('.e-toolbar-item'), args.draggedItem);
        let dropItemContainer = args.target.closest('.e-toolbar-items');
        let dropItemIndex = (dropItemContainer != null) ? (Array.prototype.slice.call(dropItemContainer.querySelectorAll('.e-toolbar-item'))).indexOf(dropItem) : -1;
        secondTabObj.current.addTab(firstTabitem, dropItemIndex);
        firstTabObj.current.removeTab(dragItemIndex);
      }
    }
  }

  const secondTabDragStart = (args) => {
    secondTabitem = [secondTabObj.current.items[args.index]];
    args.draggedItem.style.visibility = 'hidden';
    dragItemContainer = args.draggedItem.closest('.e-tab');
  }

  const secondTabDragStop = (args) => {
    if (!isNullOrUndefined(args.target.closest('.e-tab')) && !dragItemContainer.isSameNode(args.target.closest('.e-tab'))) {
      args.cancel = true;
      let TabElement = args.target.closest('.e-tab');
      let dropItem = args.target.closest('.e-toolbar-item');
      if (TabElement != null && dropItem != null) {
        dragItemIndex = Array.prototype.indexOf.call(secondTabObj.current.element.querySelectorAll('.e-toolbar-item'), args.draggedItem);
        let dropItemContainer = args.target.closest('.e-toolbar-items');
        let dropItemIndex = (dropItemContainer != null) ? (Array.prototype.slice.call(dropItemContainer.querySelectorAll('.e-toolbar-item'))).indexOf(dropItem) : -1;
        firstTabObj.current.addTab(secondTabitem, dropItemIndex);
        secondTabObj.current.removeTab(dragItemIndex);
      }
    }
  }

  const indiaContent = () => {
    return <div>
      India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.
    </div>;
  }
  const ausContent = () => {
    return <div>
      Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.
    </div>;
  }
  const usaContent = () => {
    return <div>
      The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.
    </div>;
  }
  const franceContent = () => {
    return <div>
      France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.
    </div>;
  }
  const htmlContent = () => {
    return <div>
      HyperText Markup Language, commonly referred to as HTML, is the standard markup language used to create web pages. Along with CSS, and JavaScript, HTML is a cornerstone technology, used by most websites to create visually engaging web pages, user interfaces for web applications, and user interfaces for many mobile applications.[1] Web browsers can read HTML files and render them into visible or audible web pages. HTML describes the structure of a website semantically along with cues for presentation, making it a markup language, rather than a programming language.
    </div>;
  }
  const csharpContent = () => {
    return <div>
      C# is intended to be a simple, modern, general-purpose, object-oriented programming language. Its development team is led by Anders Hejlsberg. The most recent version is C# 5.0, which was released on August 15, 2012.
    </div>;
  }
  const javaContent = () => {
    return <div>
      Java is a set of computer software and specifications developed by Sun Microsystems, later acquired by Oracle Corporation, that provides a system for developing application software and deploying it in a cross-platform computing environment. Java is used in a wide variety of computing platforms from embedded devices and mobile phones to enterprise servers and supercomputers. While less common, Java applets run in secure, sandboxed environments to provide many features of native applications and can be embedded in HTML pages.
    </div>;
  }
  const vbNetContent = () => {
    return <div>
      The command-line compiler, VBC.EXE, is installed as part of the freeware .NET Framework SDK. Mono also includes a command-line VB.NET compiler. The most recent version is VB 2012, which was released on August 15, 2012.
    </div>;
  }

  return (
    <div>
      <TabComponent ref={firstTabObj} id='firstTab' heightAdjustMode='Auto' allowDragAndDrop={allowDragAndDrop} dragArea="#container" onDragStart={firstTabdragStart} dragged={firstTabDragStop}>
        <TabItemsDirective>
          <TabItemDirective header={headerText[0]} content={indiaContent} />
          <TabItemDirective header={headerText[1]} content={ausContent} />
          <TabItemDirective header={headerText[2]} content={usaContent} />
          <TabItemDirective header={headerText[3]} content={franceContent} />
        </TabItemsDirective>
      </TabComponent>
      <br></br>
      <TabComponent ref={secondTabObj} id='secondTab' heightAdjustMode='Auto' allowDragAndDrop={allowDragAndDrop} dragArea="#container" onDragStart={secondTabDragStart} dragged={secondTabDragStop}>
        <TabItemsDirective>
          <TabItemDirective header={headerText[4]} content={htmlContent} />
          <TabItemDirective header={headerText[5]} content={csharpContent} />
          <TabItemDirective header={headerText[6]} content={javaContent} />
          <TabItemDirective header={headerText[7]} content={vbNetContent} />
        </TabItemsDirective>
      </TabComponent>
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);
import { useRef } from 'react';
import * as React from "react";
import * as ReactDOM from 'react-dom';
import { TabComponent, TabItemDirective, TabItemsDirective, DragEventArgs } from '@syncfusion/ej2-react-navigations';
import { isNullOrUndefined } from "@syncfusion/ej2-base";
const ReactApp = () => {

  const firstTabObj = useRef<TabComponent>(null);
  const secondTabObj = useRef<TabComponent>(null);
  let headerText: any = [{ text: "India" }, { text: "Australia" }, { text: "USA" }, { text: "France" }, { text: "HTML" }, { text: "C Sharp(C#)" }, { text: "Java" }, { text: "VB.Net" }];
  let allowDragAndDrop: boolean = true;
  let firstTabitem: Object[] = [];
  let secondTabitem: Object[] = [];
  let dragItemIndex: number;
  let dragItemContainer: Element;

  const firstTabdragStart = (args: DragEventArgs) => {
    firstTabitem = [firstTabObj.current.items[args.index]];
    args.draggedItem.style.visibility = 'hidden';
    dragItemContainer = args.draggedItem.closest('.e-tab') as Element;
  }

  const firstTabDragStop = (args: DragEventArgs) => {
    if (!isNullOrUndefined(args.target.closest('.e-tab') as HTMLElement) && !dragItemContainer.isSameNode(args.target.closest('.e-tab'))) {
      args.cancel = true;
      let TabElement: Element = args.target.closest('.e-tab') as Element;
      let dropItem: Element = args.target.closest('.e-toolbar-item') as Element;
      if (TabElement != null && dropItem != null) {
        dragItemIndex = Array.prototype.indexOf.call(firstTabObj.current.element.querySelectorAll('.e-toolbar-item'), args.draggedItem);
        let dropItemContainer: Element = args.target.closest('.e-toolbar-items') as Element;
        let dropItemIndex: number = (dropItemContainer != null) ? (Array.prototype.slice.call(dropItemContainer.querySelectorAll('.e-toolbar-item'))).indexOf(dropItem) : -1;
        secondTabObj.current.addTab(firstTabitem, dropItemIndex);
        firstTabObj.current.removeTab(dragItemIndex);
      }
    }
  }

  const secondTabDragStart = (args: DragEventArgs) => {
    secondTabitem = [secondTabObj.current.items[args.index]];
    args.draggedItem.style.visibility = 'hidden';
    dragItemContainer = args.draggedItem.closest('.e-tab') as Element;
  }

  const secondTabDragStop = (args: DragEventArgs) => {
    if (!isNullOrUndefined(args.target.closest('.e-tab') as HTMLElement) && !dragItemContainer.isSameNode(args.target.closest('.e-tab'))) {
      args.cancel = true;
      let TabElement: Element = args.target.closest('.e-tab') as Element;
      let dropItem: Element = args.target.closest('.e-toolbar-item') as Element;
      if (TabElement != null && dropItem != null) {
        dragItemIndex = Array.prototype.indexOf.call(secondTabObj.current.element.querySelectorAll('.e-toolbar-item'), args.draggedItem);
        let dropItemContainer: Element = args.target.closest('.e-toolbar-items') as Element;
        let dropItemIndex: number = (dropItemContainer != null) ? (Array.prototype.slice.call(dropItemContainer.querySelectorAll('.e-toolbar-item'))).indexOf(dropItem) : -1;
        firstTabObj.current.addTab(secondTabitem, dropItemIndex);
        secondTabObj.current.removeTab(dragItemIndex);
      }
    }
  }

  const indiaContent = () => {
    return <div>
      India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.
    </div>;
  }
  const ausContent = () => {
    return <div>
      Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.
    </div>;
  }
  const usaContent = () => {
    return <div>
      The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.
    </div>;
  }
  const franceContent = () => {
    return <div>
      France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.
    </div>;
  }
  const htmlContent = () => {
    return <div>
      HyperText Markup Language, commonly referred to as HTML, is the standard markup language used to create web pages. Along with CSS, and JavaScript, HTML is a cornerstone technology, used by most websites to create visually engaging web pages, user interfaces for web applications, and user interfaces for many mobile applications.[1] Web browsers can read HTML files and render them into visible or audible web pages. HTML describes the structure of a website semantically along with cues for presentation, making it a markup language, rather than a programming language.
    </div>;
  }
  const csharpContent = () => {
    return <div>
      C# is intended to be a simple, modern, general-purpose, object-oriented programming language. Its development team is led by Anders Hejlsberg. The most recent version is C# 5.0, which was released on August 15, 2012.
    </div>;
  }
  const javaContent = () => {
    return <div>
      Java is a set of computer software and specifications developed by Sun Microsystems, later acquired by Oracle Corporation, that provides a system for developing application software and deploying it in a cross-platform computing environment. Java is used in a wide variety of computing platforms from embedded devices and mobile phones to enterprise servers and supercomputers. While less common, Java applets run in secure, sandboxed environments to provide many features of native applications and can be embedded in HTML pages.
    </div>;
  }
  const vbNetContent = () => {
    return <div>
      The command-line compiler, VBC.EXE, is installed as part of the freeware .NET Framework SDK. Mono also includes a command-line VB.NET compiler. The most recent version is VB 2012, which was released on August 15, 2012.
    </div>;
  }

  return (
    <div>
      <TabComponent ref={firstTabObj} id='firstTab' heightAdjustMode='Auto' allowDragAndDrop={allowDragAndDrop} dragArea="#container" onDragStart={firstTabdragStart} dragged={firstTabDragStop}>
        <TabItemsDirective>
          <TabItemDirective header={headerText[0]} content={indiaContent} />
          <TabItemDirective header={headerText[1]} content={ausContent} />
          <TabItemDirective header={headerText[2]} content={usaContent} />
          <TabItemDirective header={headerText[3]} content={franceContent} />
        </TabItemsDirective>
      </TabComponent>
      <br></br>
      <TabComponent ref={secondTabObj} id='secondTab' heightAdjustMode='Auto' allowDragAndDrop={allowDragAndDrop} dragArea="#container" onDragStart={secondTabDragStart} dragged={secondTabDragStop}>
        <TabItemsDirective>
          <TabItemDirective header={headerText[4]} content={htmlContent} />
          <TabItemDirective header={headerText[5]} content={csharpContent} />
          <TabItemDirective header={headerText[6]} content={javaContent} />
          <TabItemDirective header={headerText[7]} content={vbNetContent} />
        </TabItemsDirective>
      </TabComponent>
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);

Drag and drop items to external source

It is possible to drag and drop the items to any of the external sources from the Tab, by manually saving those dropped items as new node data through the addNodes method of Treeview and removing the dragged item through the removeTab method of Tab.

In this example, we have used the tree view control as an external source, and the item from the tab component is dragged and dropped onto the child nodes of the tree view component. Therefore, it is necessary to use the dragged event of the Tab component, where we can form an event object and save it using the addNodes method of the Treeview and remove the dragged item through the removeTab method of Tab using the dragged item index.

import { useRef, useEffect } from 'react';
import * as React from "react";
import * as ReactDOM from 'react-dom';
import { TabComponent, TabItemDirective, TabItemsDirective, TreeViewComponent } from '@syncfusion/ej2-react-navigations';
import { isNullOrUndefined } from "@syncfusion/ej2-base";
const ReactApp = () => {
  const tabObj = useRef(null);
  const treeObj = useRef(null);
  let headerText = [{ text: "India" }, { text: "Australia" }, { text: "USA" }, { text: "France" }];
  let allowDragAndDrop = true;
  let data = [
    { text: 'Hennessey Venom', id: 'list-01' },
    { text: 'Bugatti Chiron', id: 'list-02' },
    { text: 'Bugatti Veyron Super Sport', id: 'list-03' },
    { text: 'SSC Ultimate Aero', id: 'list-04' },
    { text: 'Koenigsegg CCR', id: 'list-05' },
    { text: 'McLaren F1', id: 'list-06' },
    { text: 'Aston Martin One- 77', id: 'list-07' },
    { text: 'Jaguar XJ220', id: 'list-08' },
    { text: 'McLaren P1', id: 'list-09' },
    { text: 'Ferrari LaFerrari', id: 'list-10' },
  ];
  let field = { dataSource: data, id: 'id', text: 'text' };
  let i = 0;

  useEffect(() => {
    const tabElement = tabObj.current.element;
    if (!isNullOrUndefined(tabElement)) {
      tabElement.querySelector('.e-tab-header').classList.add('e-droppable');
      tabElement.querySelector('.e-content').classList.add('tab-content');
    }
  }, []);

  const tabDragStop = (args) => {
    const dragTabIndex = Array.prototype.indexOf.call(tabObj.current.element.querySelectorAll('.e-toolbar-item'), args.draggedItem);
    const dragItem = tabObj.current.items[dragTabIndex];
    const dropNode = args.target.closest('#draggableTreeview .e-list-item');
    if (dropNode != null && !args.target.closest('#draggableTab .e-toolbar-item')) {
      args.cancel = true;
      const dropContainer = document.querySelector('.treeview-external-drop-tab').querySelectorAll('.e-list-item');
      const dropIndex = Array.prototype.indexOf.call(dropContainer, dropNode);
      const newNode = [{ id: 'list' + i, text: dragItem.header ? dragItem.header.text : '' }];
      tabObj.current.removeTab(dragTabIndex);
      treeObj.current.addNodes(newNode, 'Treeview', dropIndex);
    }
  }

  const indiaContent = () => {
    return <div>
      India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.
    </div>;
  }
  const ausContent = () => {
    return <div>
      Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.
    </div>;
  }
  const usaContent = () => {
    return <div>
      The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.
    </div>;
  }
  const franceContent = () => {
    return <div>
      France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.
    </div>;
  }

  return (
    <div>
      <TabComponent ref={tabObj} heightAdjustMode='Auto' allowDragAndDrop={allowDragAndDrop} dragArea="#container" dragged={tabDragStop}>
        <TabItemsDirective>
          <TabItemDirective header={headerText[0]} content={indiaContent} />
          <TabItemDirective header={headerText[1]} content={ausContent} />
          <TabItemDirective header={headerText[2]} content={usaContent} />
          <TabItemDirective header={headerText[3]} content={franceContent} />
        </TabItemsDirective>
      </TabComponent>
      <br></br>
      <TreeViewComponent id="draggableTreeview" ref={treeObj} cssClass="treeview-external-drop-tab" fields={field} />
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);
import { useRef, useEffect } from 'react';
import * as React from "react";
import * as ReactDOM from 'react-dom';
import { TabComponent, TabItemDirective, TabItemsDirective, TreeViewComponent } from '@syncfusion/ej2-react-navigations';
import { isNullOrUndefined } from "@syncfusion/ej2-base";
const ReactApp = () => {
  const tabObj = useRef<TabComponent>(null);
  const treeObj = useRef<TreeViewComponent>(null);
  let headerText: any = [{ text: "India" }, { text: "Australia" }, { text: "USA" }, { text: "France" }];
  let allowDragAndDrop: boolean = true;
  let data: { [key: string]: Object }[] = [
    { text: 'Hennessey Venom', id: 'list-01' },
    { text: 'Bugatti Chiron', id: 'list-02' },
    { text: 'Bugatti Veyron Super Sport', id: 'list-03' },
    { text: 'SSC Ultimate Aero', id: 'list-04' },
    { text: 'Koenigsegg CCR', id: 'list-05' },
    { text: 'McLaren F1', id: 'list-06' },
    { text: 'Aston Martin One- 77', id: 'list-07' },
    { text: 'Jaguar XJ220', id: 'list-08' },
    { text: 'McLaren P1', id: 'list-09' },
    { text: 'Ferrari LaFerrari', id: 'list-10' },
  ];
  let field: Object = { dataSource: data, id: 'id', text: 'text' };
  let i: number = 0;

  useEffect(() => {
    const tabElement = tabObj.current.element;
    if (!isNullOrUndefined(tabElement)) {
      tabElement.querySelector('.e-tab-header').classList.add('e-droppable');
      tabElement.querySelector('.e-content').classList.add('tab-content');
    }
  }, []);

  const tabDragStop = (args) => {
    const dragTabIndex = Array.prototype.indexOf.call(tabObj.current.element.querySelectorAll('.e-toolbar-item'), args.draggedItem);
    const dragItem = tabObj.current.items[dragTabIndex];
    const dropNode = args.target.closest('#draggableTreeview .e-list-item');
    if (dropNode != null && !args.target.closest('#draggableTab .e-toolbar-item')) {
      args.cancel = true;
      const dropContainer = document.querySelector('.treeview-external-drop-tab').querySelectorAll('.e-list-item');
      const dropIndex = Array.prototype.indexOf.call(dropContainer, dropNode);
      const newNode = [{ id: 'list' + i, text: dragItem.header ? dragItem.header.text : '' }];
      tabObj.current.removeTab(dragTabIndex);
      treeObj.current.addNodes(newNode, 'Treeview', dropIndex);
    }
  }

  const indiaContent = () => {
    return <div>
      India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.
    </div>;
  }
  const ausContent = () => {
    return <div>
      Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.
    </div>;
  }
  const usaContent = () => {
    return <div>
      The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.
    </div>;
  }
  const franceContent = () => {
    return <div>
      France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.
    </div>;
  }

  return (
    <div>
      <TabComponent ref={tabObj} heightAdjustMode='Auto' allowDragAndDrop={allowDragAndDrop} dragArea="#container" dragged={tabDragStop}>
        <TabItemsDirective>
          <TabItemDirective header={headerText[0]} content={indiaContent} />
          <TabItemDirective header={headerText[1]} content={ausContent} />
          <TabItemDirective header={headerText[2]} content={usaContent} />
          <TabItemDirective header={headerText[3]} content={franceContent} />
        </TabItemsDirective>
      </TabComponent>
      <br></br>
      <TreeViewComponent id="draggableTreeview" ref={treeObj} cssClass="treeview-external-drop-tab" fields={field} />
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);

Drag and drop items from external source

It is possible to drag and drop the items from any of the external sources into the Tab, by manually saving those dropped items as new item data through the addTab method of Tab and removing the dragged node through the removeNodes method of Treeview.

In this example, we have used the tree view control as an external source, and the child nodes from the tree view component are dragged and dropped onto the Tab. Therefore, it is necessary to use the nodeDragStop event of the Treeview component, where we can form an event object and save it using the addTab method of the Tab and remove the dragged node through the removeNodes method of Treeview.

import { useRef } from 'react';
import * as React from "react";
import * as ReactDOM from 'react-dom';
import { TabComponent, TabItemDirective, TabItemsDirective, TreeViewComponent } from '@syncfusion/ej2-react-navigations';
import { isNullOrUndefined } from "@syncfusion/ej2-base";

const ReactApp = () => {
  const tabObj = useRef(null);
  const treeObj = useRef(null);
  let headerText = [{ text: "India" }, { text: "Australia" }, { text: "USA" }, { text: "France" }];
  let allowDragAndDrop = true;
  let data = [
    { text: 'Hennessey Venom', id: 'list-01' },
    { text: 'Bugatti Chiron', id: 'list-02' },
    { text: 'Bugatti Veyron Super Sport', id: 'list-03' },
    { text: 'SSC Ultimate Aero', id: 'list-04' },
    { text: 'Koenigsegg CCR', id: 'list-05' },
    { text: 'McLaren F1', id: 'list-06' },
    { text: 'Aston Martin One- 77', id: 'list-07' },
    { text: 'Jaguar XJ220', id: 'list-08' },
    { text: 'McLaren P1', id: 'list-09' },
    { text: 'Ferrari LaFerrari', id: 'list-10' },
  ];
  let field = { dataSource: data, id: 'id', text: 'text' };

  const onNodeDragStop = (args) => {
    let dropElement = args.target.closest('#draggableTab .e-toolbar-item');
    if (dropElement != null) {
      let tabElement = tabObj.current.element;
      let dropItemIndex = [].slice.call(tabElement.querySelectorAll('.e-toolbar-item')).indexOf(dropElement);
      let newTabItem = [{
        header: { 'text': args.draggedNodeData.text.toString() },
        content: args.draggedNodeData.text.toString() + ' Content'
      }];
      tabObj.current.addTab(newTabItem, dropItemIndex);
      treeObj.current.removeNodes([args.draggedNode]);
      args.cancel = true;
    } else {
      let dropNode = args.target.closest('#draggableTreeview .e-list-item ');
      if (!isNullOrUndefined(dropNode) && args.dropIndicator === 'e-drop-in') {
        args.cancel = true;
      }
    }
  }

  const onNodeDrag = (args) => {
    if (!isNullOrUndefined(args.target.closest('.tab-content'))) {
      args.dropIndicator = 'e-no-drop';
    } else if (!isNullOrUndefined(args.target.closest('#draggableTab .e-tab-header'))) {
      args.dropIndicator = 'e-drop-in';
    }
  }

  const indiaContent = () => {
    return <div>
      India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.
    </div>;
  }
  const ausContent = () => {
    return <div>
      Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.
    </div>;
  }
  const usaContent = () => {
    return <div>
      The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.
    </div>;
  }
  const franceContent = () => {
    return <div>
      France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.
    </div>;
  }

  return (
    <div>
      <TabComponent ref={tabObj} id='draggableTab' heightAdjustMode='Auto' dragArea="#container">
        <TabItemsDirective>
          <TabItemDirective header={headerText[0]} content={indiaContent} />
          <TabItemDirective header={headerText[1]} content={ausContent} />
          <TabItemDirective header={headerText[2]} content={usaContent} />
          <TabItemDirective header={headerText[3]} content={franceContent} />
        </TabItemsDirective>
      </TabComponent>
      <br></br>
      <TreeViewComponent id="draggableTreeview" ref={treeObj} dragArea="#container" cssClass="treeview-external-drop-tab" fields={field} nodeDragStop={onNodeDragStop} nodeDragging={onNodeDrag} allowDragAndDrop={allowDragAndDrop} />
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);
import { useRef } from 'react';
import * as React from "react";
import * as ReactDOM from 'react-dom';
import { TabComponent, TabItemDirective, TabItemsDirective, TabItemModel, TreeViewComponent, DragAndDropEventArgs } from '@syncfusion/ej2-react-navigations';
import { isNullOrUndefined } from "@syncfusion/ej2-base";

const ReactApp = () => {
  const tabObj = useRef<TabComponent>(null);
  const treeObj = useRef<TreeViewComponent>(null);
  let headerText: any = [{ text: "India" }, { text: "Australia" }, { text: "USA" }, { text: "France" }];
  let allowDragAndDrop: boolean = true;
  let data: { [key: string]: Object }[] = [
    { text: 'Hennessey Venom', id: 'list-01' },
    { text: 'Bugatti Chiron', id: 'list-02' },
    { text: 'Bugatti Veyron Super Sport', id: 'list-03' },
    { text: 'SSC Ultimate Aero', id: 'list-04' },
    { text: 'Koenigsegg CCR', id: 'list-05' },
    { text: 'McLaren F1', id: 'list-06' },
    { text: 'Aston Martin One- 77', id: 'list-07' },
    { text: 'Jaguar XJ220', id: 'list-08' },
    { text: 'McLaren P1', id: 'list-09' },
    { text: 'Ferrari LaFerrari', id: 'list-10' },
  ];
  let field: Object = { dataSource: data, id: 'id', text: 'text' };

  const onNodeDragStop = (args: DragAndDropEventArgs) => {
    let dropElement: Element = args.target.closest('#draggableTab .e-toolbar-item') as Element;
    if (dropElement != null) {
      let tabElement: HTMLElement = tabObj.current.element;
      let dropItemIndex: number = [].slice.call(tabElement.querySelectorAll('.e-toolbar-item')).indexOf(dropElement as never);
      let newTabItem: TabItemModel[] = [{
        header: { 'text': args.draggedNodeData.text.toString() },
        content: args.draggedNodeData.text.toString() + ' Content'
      }];
      tabObj.current.addTab(newTabItem, dropItemIndex);
      treeObj.current.removeNodes([args.draggedNode]);
      args.cancel = true;
    } else {
      let dropNode: Element = args.target.closest('#draggableTreeview .e-list-item ') as Element;
      if (!isNullOrUndefined(dropNode) && args.dropIndicator === 'e-drop-in') {
        args.cancel = true;
      }
    }
  }

  const onNodeDrag = (args: DragAndDropEventArgs) => {
    if (!isNullOrUndefined(args.target.closest('.tab-content') as HTMLElement)) {
      args.dropIndicator = 'e-no-drop';
    } else if (!isNullOrUndefined(args.target.closest('#draggableTab .e-tab-header') as HTMLElement)) {
      args.dropIndicator = 'e-drop-in';
    }
  }

  const indiaContent = () => {
    return <div>
      India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.
    </div>;
  }
  const ausContent = () => {
    return <div>
      Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.
    </div>;
  }
  const usaContent = () => {
    return <div>
      The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.
    </div>;
  }
  const franceContent = () => {
    return <div>
      France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.
    </div>;
  }

  return (
    <div>
      <TabComponent ref={tabObj} id='draggableTab' heightAdjustMode='Auto' dragArea="#container">
        <TabItemsDirective>
          <TabItemDirective header={headerText[0]} content={indiaContent} />
          <TabItemDirective header={headerText[1]} content={ausContent} />
          <TabItemDirective header={headerText[2]} content={usaContent} />
          <TabItemDirective header={headerText[3]} content={franceContent} />
        </TabItemsDirective>
      </TabComponent>
      <br></br>
      <TreeViewComponent id="draggableTreeview" ref={treeObj} dragArea="#container" cssClass="treeview-external-drop-tab" fields={field} nodeDragStop={onNodeDragStop} nodeDragging={onNodeDrag} allowDragAndDrop={allowDragAndDrop} />
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);

Drag and drop in Angular Tab component

23 Jan 202424 minutes to read

The Tab component allows you to drag and drop any item by setting allowDragAndDrop to true. Items can be reordered to any place by dragging and dropping them onto the desired location.

  • If you need to prevent dragging action for a particular item, the onDragStart event can be used which will trigger when the item drag is started. If you need to prevent dropping action for a particular item, the dragged event can be used which will trigger when the drag action is stopped.

  • The dragArea defines the area in which the draggable element movement will be occurring. Outside that area will be restricted for the draggable element movement.

  • The onDragStart event will be triggered before dragging the item from Tab.

  • The dragging event will be triggered when the Tab item is being dragged.

  • The dragged event will be triggered when the Tab item is dropped on the target element successfully.

In the following sample, the allowDragAndDrop property is enabled.

import { Component } from '@angular/core';

/**
 * Tab Component
 */

@Component({
    selector: 'app-container',
    template: `<div id='tabparent'><ejs-tab id="draggableTab" heightAdjustMode='Auto' [allowDragAndDrop]='true' dragArea='#tabparent'>
            <e-tabitems>
                <e-tabitem [header]='headerText[0]' [content]="content0"></e-tabitem>
                <e-tabitem [header]='headerText[1]' [content]="content1"></e-tabitem>
                <e-tabitem [header]='headerText[2]' [content]="content2"></e-tabitem>
                <e-tabitem [header]='headerText[3]' [content]="content3"></e-tabitem>
            </e-tabitems>
        </ejs-tab></div>`
})

export class AppComponent {
    public headerText: Object = [{ 'text': 'India' }, { 'text': 'Australia' }, { 'text': 'USA' }, { 'text': 'France' }];

    public content0: string = 'India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.';

    public content1: string = 'Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.';

    public content2: string = 'The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.';

    public content3: string = 'France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.';
}
import { NgModule } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { BrowserModule } from '@angular/platform-browser';

import { TabAllModule } from '@syncfusion/ej2-angular-navigations';

import { AppComponent } from './app.component';

/**
 * Module
 */
@NgModule({
    imports: [
        FormsModule,
        TabAllModule,
        BrowserModule,
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

import 'zone.js';
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

Drag and drop item between tabs

It is possible to drag and drop the tab items between two tabs, by manually saving those dropped items as new tab item data through the addTab method of Tab and removing the dragged item through the removeTab method of Tab.

In this example, we have used the tab control as an external source, and the item from the tab component is dragged and dropped onto another Tab. Therefore, it is necessary to use the onDragStart and dragged event of the Tab component, where we can form an event object and save it using the addTab method of the Tab and remove the dragged item through removeTab method of Tab using the dragged item index.

<div id='tabparent'>
    <ejs-tab #firstTabObj id="firstTab" heightAdjustMode='Auto' [allowDragAndDrop]='true' dragArea='#tabparent'
    (onDragStart)='firstTabdragStart($event)' (dragged)='firstTabDragStop($event)'>
    <e-tabitems>
        <e-tabitem [header]='headerText[0]' [content]="content0"></e-tabitem>
        <e-tabitem [header]='headerText[1]' [content]="content1"></e-tabitem>
        <e-tabitem [header]='headerText[2]' [content]="content2"></e-tabitem>
        <e-tabitem [header]='headerText[3]' [content]="content3"></e-tabitem>
    </e-tabitems>
    </ejs-tab>
    <ejs-tab #secondTabObj id="secondTab" heightAdjustMode='Auto' [allowDragAndDrop]='true' dragArea='#tabparent'
    (onDragStart)='secondTabDragStart($event)' (dragged)='secondTabDragStop($event)'>
    <e-tabitems>
        <e-tabitem [header]='headerText[4]' [content]="content4"></e-tabitem>
        <e-tabitem [header]='headerText[5]' [content]="content5"></e-tabitem>
        <e-tabitem [header]='headerText[6]' [content]="content6"></e-tabitem>
        <e-tabitem [header]='headerText[7]' [content]="content7"></e-tabitem>
    </e-tabitems>
    </ejs-tab>
</div>
import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { TabComponent, DragEventArgs } from '@syncfusion/ej2-angular-navigations';
import { isNullOrUndefined } from "@syncfusion/ej2-base";

/**
 * Tab Component
 */

@Component({
    selector: 'app-container',
    templateUrl: './app.component.html',
    encapsulation: ViewEncapsulation.None
})

export class AppComponent {
    @ViewChild('firstTabObj') public firstTabObj?: TabComponent;
    @ViewChild('secondTabObj') public secondTabObj?: TabComponent;

    public headerText: Object[] = [{ 'text': 'India' }, { 'text': 'Australia' }, { 'text': 'USA' }, { 'text': 'France' }, { 'text': 'HTML' }, { 'text': 'C Sharp(C#)' }, { 'text': 'Java' }, { 'text': 'VB.Net' }];
    public firstTabitem: Object[] = [];
    public secondTabitem: Object[] = [];
    public dragItemIndex?: number;
    public dragItemContainer?: HTMLElement;

    public content0: string = 'India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.';

    public content1: string = 'Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.';

    public content2: string = 'The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.';

    public content3: string = 'France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.';

    public content4: string = 'HyperText Markup Language, commonly referred to as HTML, is the standard markup language used to create web pages. Along with CSS, and JavaScript, HTML is a cornerstone technology, used by most websites to create visually engaging web pages, user interfaces for web applications, and user interfaces for many mobile applications.[1] Web browsers can read HTML files and render them into visible or audible web pages. HTML describes the structure of a website semantically along with cues for presentation, making it a markup language, rather than a programming language.';

    public content5: string = 'C# is intended to be a simple, modern, general-purpose, object-oriented programming language. Its development team is led by Anders Hejlsberg. The most recent version is C# 5.0, which was released on August 15, 2012.';

    public content6: string = 'Java is a set of computer software and specifications developed by Sun Microsystems, later acquired by Oracle Corporation, that provides a system for developing application software and deploying it in a cross-platform computing environment. Java is used in a wide variety of computing platforms from embedded devices and mobile phones to enterprise servers and supercomputers. While less common, Java applets run in secure, sandboxed environments to provide many features of native applications and can be embedded in HTML pages.';

    public content7: string = 'The command-line compiler, VBC.EXE, is installed as part of the freeware .NET Framework SDK. Mono also includes a command-line VB.NET compiler. The most recent version is VB 2012, which was released on August 15, 2012.';

    firstTabdragStart(args: DragEventArgs): void {
        this.firstTabitem = [(this.firstTabObj as TabComponent).items[args.index]];
        args.draggedItem.style.visibility = 'hidden';
        this.dragItemContainer = <HTMLElement>args.draggedItem.closest('.e-tab');
    }

    firstTabDragStop(args: DragEventArgs): void {
        if (!isNullOrUndefined((args.target as HTMLElement).closest('.e-tab') as Element) && !(this.dragItemContainer as HTMLElement).isSameNode(args.target.closest('.e-tab'))) {
            args.cancel = true;
            let TabElement: HTMLElement = <HTMLElement>args.target.closest('.e-tab');
            let dropItem: HTMLElement = <HTMLElement>args.target.closest('.e-toolbar-item');
            if (TabElement != null && dropItem != null) {
                const childrenArray = Array.from((this.firstTabObj as TabComponent).element.children[0].children[0].children);
                const toolbarItem: Element[] = childrenArray.filter(el => el.classList.contains('e-toolbar-item'));
                this.dragItemIndex = toolbarItem.indexOf(args.draggedItem);
                let dropItemContainer: Element = args.target.closest('.e-toolbar-items') as Element;
                let dropChildArray: Element[] = (Array.from(dropItemContainer.children)).filter(el => el.classList.contains('e-toolbar-item'));
                let dropItemIndex: number = (dropItemContainer != null) ? dropChildArray.indexOf(dropItem) as number : '' as any;
                (this.secondTabObj as TabComponent).addTab(this.firstTabitem, dropItemIndex);
                (this.firstTabObj as TabComponent).removeTab(this.dragItemIndex);
            }
        }
    }

    secondTabDragStart(args: DragEventArgs): void {
        this.secondTabitem = [(this.secondTabObj as TabComponent).items[args.index]];
        args.draggedItem.style.visibility = 'hidden';
        this.dragItemContainer = <HTMLElement>args.draggedItem.closest('.e-tab');
    }

    secondTabDragStop(args: DragEventArgs): void {
        if (!isNullOrUndefined(args.target.closest('.e-tab') as Element) && !(this.dragItemContainer as HTMLElement).isSameNode(args.target.closest('.e-tab'))) {
            args.cancel = true;
            let TabElement: HTMLElement = <HTMLElement>args.target.closest('.e-tab');
            let dropItem: HTMLElement = <HTMLElement>args.target.closest('.e-toolbar-item');
            if (TabElement != null && dropItem != null) {
                const childrenArray = Array.from((this.secondTabObj as TabComponent).element.children[0].children[0].children);
                const toolbarItem: Element[] = childrenArray.filter(el => el.classList.contains('e-toolbar-item'));
                this.dragItemIndex = toolbarItem.indexOf(args.draggedItem);
                let dropItemContainer: Element = args.target.closest('.e-toolbar-items') as Element;
                let dropChildArray: Element[] = (Array.from(dropItemContainer.children)).filter(el => el.classList.contains('e-toolbar-item'));
                let dropItemIndex: number = (dropItemContainer != null) ? dropChildArray.indexOf(dropItem) as number : '' as any;
                (this.firstTabObj as TabComponent).addTab(this.secondTabitem, dropItemIndex);
                (this.secondTabObj as TabComponent).removeTab(this.dragItemIndex);
            }
        }
    }
}
import { NgModule } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { BrowserModule } from '@angular/platform-browser';

import { TabAllModule } from '@syncfusion/ej2-angular-navigations';

import { AppComponent } from './app.component';

/**
 * Module
 */
@NgModule({
    imports: [
        FormsModule,
        TabAllModule,
        BrowserModule,
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

import 'zone.js';
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

Drag and drop items to external source

It is possible to drag and drop the items to any of the external sources from the Tab, by manually saving those dropped items as new node data through the addNodes method of Treeview and removing the dragged item through the removeTab method of Tab.

In this example, we have used the tree view control as an external source, and the item from the tab component is dragged and dropped onto the child nodes of the tree view component. Therefore, it is necessary to use the dragged event of the Tab component, where we can form an event object and save it using the addNodes method of the Treeview and remove the dragged item through the removeTab method of Tab using the dragged item index.

<div id='tabparent'>
    <ejs-tab #tabObj id="draggableTab" heightAdjustMode='Auto' [allowDragAndDrop]='true' dragArea='#tabparent'
    (created)='onTabCreate()' (dragged)='tabDragStop($event)'>
    <e-tabitems>
        <e-tabitem [header]='headerText[0]' [content]="content0"></e-tabitem>
        <e-tabitem [header]='headerText[1]' [content]="content1"></e-tabitem>
        <e-tabitem [header]='headerText[2]' [content]="content2"></e-tabitem>
        <e-tabitem [header]='headerText[3]' [content]="content3"></e-tabitem>
    </e-tabitems>
    </ejs-tab>
    <ejs-treeview #treeObj id='draggableTreeview' [fields]='field' cssClass='treeview-external-drop-tab'>
    </ejs-treeview>
</div>
import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { TabComponent, DragEventArgs, TabItemModel, TreeViewComponent, HeaderModel } from '@syncfusion/ej2-angular-navigations';
import { isNullOrUndefined } from "@syncfusion/ej2-base";

/**
 * Tab Component
 */

@Component({
    selector: 'app-container',
    templateUrl: './app.component.html',
    encapsulation: ViewEncapsulation.None
})

export class AppComponent {
    @ViewChild('tabObj') tabObj?: TabComponent;
    @ViewChild('treeObj') treeObj?: TreeViewComponent;

    public headerText: Object[] = [{ 'text': 'India' }, { 'text': 'Australia' }, { 'text': 'USA' }, { 'text': 'France' }];

    public content0: string = 'India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.';

    public content1: string = 'Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.';

    public content2: string = 'The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.';

    public content3: string = 'France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.';

    public field: Object = {
        dataSource: [
            { text: 'Hennessey Venom', id: 'list-01' },
            { text: 'Bugatti Chiron', id: 'list-02' },
            { text: 'Bugatti Veyron Super Sport', id: 'list-03' },
            { text: 'SSC Ultimate Aero', id: 'list-04' },
            { text: 'Koenigsegg CCR', id: 'list-05' },
            { text: 'McLaren F1', id: 'list-06' },
            { text: 'Aston Martin One- 77', id: 'list-07' },
            { text: 'Jaguar XJ220', id: 'list-08' },
            { text: 'McLaren P1', id: 'list-09' },
            { text: 'Ferrari LaFerrari', id: 'list-10' },
        ],
        id: "id", text: "text"
    }

    public i: number = 0;

    onTabCreate(): void {
        let tabElement: HTMLElement = document.getElementById('draggableTab') as HTMLElement;
        if (!isNullOrUndefined(tabElement)) {
            (this.tabObj as TabComponent).element.children[0].classList.add('e-droppable');
            (this.tabObj as TabComponent).element.children[1].classList.add('tab-content');
        }
    }

    tabDragStop(args: DragEventArgs): void {
        const childrenArray = Array.from((this.tabObj as TabComponent).element.children[0].children[0].children);
        const toolbarItem: Element[] = childrenArray.filter(el => el.classList.contains('e-toolbar-item'));
        let dragTabIndex: number = toolbarItem.indexOf(args.draggedItem);
        let dragItem: TabItemModel = (this.tabObj as TabComponent).items[dragTabIndex];
        let dropNode: HTMLElement = <HTMLElement>args.target.closest('#draggableTreeview .e-list-item');
        if (dropNode != null && !args.target.closest('#draggableTab .e-toolbar-item')) {
            args.cancel = true;
            let dropContainer = Array.from((this.treeObj as TreeViewComponent).element.children[0].children);
            const treeViewItem: Element[] = dropContainer.filter(el => el.classList.contains('e-list-item'));
            let dropIndex: number = Array.prototype.indexOf.call(treeViewItem, dropNode);
            let newNode: { [key: string]: Object }[] = [{ id: 'list' + this.i, text: (dragItem.header as HeaderModel).text as any }];
            (this.tabObj as TabComponent).removeTab(dragTabIndex);
            this.treeObj?.addNodes(newNode, 'Treeview' , dropIndex);
        }
    }
}
import { NgModule } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { BrowserModule } from '@angular/platform-browser';

import { TabAllModule, TreeViewModule } from '@syncfusion/ej2-angular-navigations';

import { AppComponent } from './app.component';

/**
 * Module
 */
@NgModule({
    imports: [
        FormsModule,
        TabAllModule,
        BrowserModule,
        TreeViewModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

import 'zone.js';
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

Drag and drop items from external source

It is possible to drag and drop the items from any of the external sources into the Tab, by manually saving those dropped items as new item data through the addTab method of Tab and removing the dragged node through the removeNodes method of Treeview.

In this example, we have used the tree view control as an external source, and the child nodes from the tree view component are dragged and dropped onto the Tab. Therefore, it is necessary to use the nodeDragStop event of the Treeview component, where we can form an event object and save it using the addTab method of the Tab and remove the dragged node through the removeNodes method of Treeview.

<div id='tabparent'>
    <ejs-tab #tabObj id="draggableTab" heightAdjustMode='Auto' dragArea='#tabparent'>
        <e-tabitems>
            <e-tabitem [header]='headerText[0]' [content]="content0"></e-tabitem>
            <e-tabitem [header]='headerText[1]' [content]="content1"></e-tabitem>
            <e-tabitem [header]='headerText[2]' [content]="content2"></e-tabitem>
            <e-tabitem [header]='headerText[3]' [content]="content3"></e-tabitem>
        </e-tabitems>
    </ejs-tab>
    <ejs-treeview #treeObj id='draggableTreeview' [fields]='field' cssClass='treeview-external-drop-tab' dragArea='#container' [allowDragAndDrop]='true' (nodeDragStop)='onNodeDragStop($event)'
    (nodeDragging)='onNodeDrag($event)'>
    </ejs-treeview>
</div>
import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { TabComponent, TabItemModel, TreeViewComponent, DragAndDropEventArgs } from '@syncfusion/ej2-angular-navigations';
import { isNullOrUndefined } from "@syncfusion/ej2-base";

/**
 * Tab Component
 */

@Component({
    selector: 'app-container',
    templateUrl: './app.component.html',
    encapsulation: ViewEncapsulation.None
})

export class AppComponent {
    @ViewChild('tabObj') tabObj?: TabComponent;
    @ViewChild('treeObj') treeObj?: TreeViewComponent;

    public headerText: Object[] = [{ 'text': 'India' }, { 'text': 'Australia' }, { 'text': 'USA' }, { 'text': 'France' }];

    public content0: string = 'India officially the Republic of India, is a country in South Asia. It is the seventh-largest country by area, the second-most populous country with over 1.2 billion people, and the most populous democracy in the world. Bounded by the Indian Ocean on the south, the Arabian Sea on the south-west, and the Bay of Bengal on the south-east, it shares land borders with Pakistan to the west;China, Nepal, and Bhutan to the north-east; and Burma and Bangladesh to the east. In the Indian Ocean, India is in the vicinity of Sri Lanka and the Maldives; in addition, India Andaman and Nicobar Islands share a maritime border with Thailand and Indonesia.';

    public content1: string = 'Australia, officially the Commonwealth of Australia, is a country comprising the mainland of the Australian continent, the island of Tasmania and numerous smaller islands. It is the world sixth-largest country by total area. Neighboring countries include Indonesia, East Timor and Papua New Guinea to the north; the Solomon Islands, Vanuatu and New Caledonia to the north-east; and New Zealand to the south-east.';

    public content2: string = 'The United States of America (USA or U.S.A.), commonly called the United States (US or U.S.) and America, is a federal republic consisting of fifty states and a federal district. The 48 contiguous states and the federal district of Washington, D.C. are in central North America between Canada and Mexico. The state of Alaska is west of Canada and east of Russia across the Bering Strait, and the state of Hawaii is in the mid-North Pacific. The country also has five populated and nine unpopulated territories in the Pacific and the Caribbean.';

    public content3: string = 'France, officially the French Republic is a sovereign state comprising territory in western Europe and several overseas regions and territories. The European part of France, called Metropolitan France, extends from the Mediterranean Sea to the English Channel and the North Sea, and from the Rhine to the Atlantic Ocean; France covers 640,679 square kilo metres and as of August 2015 has a population of 67 million, counting all the overseas departments and territories.';

    public field: Object = {
        dataSource: [
            { text: 'Hennessey Venom', id: 'list-01' },
            { text: 'Bugatti Chiron', id: 'list-02' },
            { text: 'Bugatti Veyron Super Sport', id: 'list-03' },
            { text: 'SSC Ultimate Aero', id: 'list-04' },
            { text: 'Koenigsegg CCR', id: 'list-05' },
            { text: 'McLaren F1', id: 'list-06' },
            { text: 'Aston Martin One- 77', id: 'list-07' },
            { text: 'Jaguar XJ220', id: 'list-08' },
            { text: 'McLaren P1', id: 'list-09' },
            { text: 'Ferrari LaFerrari', id: 'list-10' },
        ],
        id: "id", text: "text"
    }

    onNodeDragStop(args: DragAndDropEventArgs): void {
        let dropElement: HTMLElement = <HTMLElement>args.target.closest('#draggableTab .e-toolbar-item');
        if (dropElement != null) {
            const childrenArray = Array.from((this.tabObj as TabComponent).element.children[0].children[0].children);
            const toolbarItem: Element[] = childrenArray.filter(el => el.classList.contains('e-toolbar-item'));
            let dropItemIndex: number = toolbarItem.indexOf(dropElement as never);
            let newTabItem: TabItemModel[] = [{
                header: { 'text': args.draggedNodeData['text'].toString() },
                content: args.draggedNodeData['text'].toString() + ' Content'
            }];
            (this.tabObj as TabComponent).addTab(newTabItem, dropItemIndex);
            this.treeObj?.removeNodes([args.draggedNode]);
            args.cancel = true;
        } else {
            let dropNode: HTMLElement = <HTMLElement>args.target.closest('#draggableTreeview .e-list-item ');
            if (!isNullOrUndefined(dropNode) && args.dropIndicator === 'e-drop-in') {
                args.cancel = true;
            }
        }
    }

    onNodeDrag(args: DragAndDropEventArgs): void {
        if (!isNullOrUndefined((args.target as HTMLElement).closest('.tab-content') as Element)) {
            args.dropIndicator = 'e-no-drop';
        } else if (!isNullOrUndefined(args.target.closest('#draggableTab .e-tab-header') as Element)) {
            args.dropIndicator = 'e-drop-in';
        }
    }
}
import { NgModule } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { BrowserModule } from '@angular/platform-browser';

import { TabAllModule, TreeViewModule } from '@syncfusion/ej2-angular-navigations';

import { AppComponent } from './app.component';

/**
 * Module
 */
@NgModule({
    imports: [
        FormsModule,
        TabAllModule,
        BrowserModule,
        TreeViewModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

import 'zone.js';
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);